/* Demo for a live signal plotter.

@Copyright (c) 1997-2002 The Regents of the University of California.
All rights reserved.

Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the
above copyright notice and the following two paragraphs appear in all
copies of this software.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

                                                PT_COPYRIGHT_VERSION_2
                                                COPYRIGHTENDKEY
@ProposedRating red (eal@eecs.berkeley.edu)
@AcceptedRating red (cxh@eecs.berkeley.edu)
*/

//package demo;

import ptolemy.plot.PlotLive;

import java.awt.Event;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JFrame;

import java.io.*;
import java.net.*;


//////////////////////////////////////////////////////////////////////////
//// PlotLiveDemo
/**
Dynamically plot a test signal, illustrating how to use the
PlotLive class.

@author Edward A. Lee
@version $Id: PlotLiveDemo.java,v 1.48.2.2 2002/06/14 17:26:25 cxh Exp $
@since Ptolemy II 0.2
*/
public class PlotLiveDemo extends PlotLive {

    /** Construct a plot for live, animated signal display.
     *  Configure the title, axes, points style, and persistence.
     */
    StringBuffer buf;
    String line;
    String line2;
    String line3;
    URL url=null;
    
    double valueX1=0;
    double valueX2=0;
    double valueY1=3;
    double valueY2=3;
    double tempX1 = 0;
    double tempY1 = 0;
    
    double tempX2 = 0;
    double tempY2 = 0;
    
    int xupper = 200;
    int xlower = -1;
    
    
    
    /*public PlotLiveDemo() {
        setYRange(-1, 6);
        setXRange(-1, 10000);
        setPointsPersistence(2000);
        setMarksStyle("points");
    }*/
    
     public PlotLiveDemo() {
        setYRange(-10, 360);
        setXRange(-1, 400);
        //setPointsPersistence(300);
        //setMarksStyle("points");
        setMarksStyle("none");
        //setConnected(false);
        // setImpulses(true);
    }

    ///////////////////////////////////////////////////////////////////
    ////                         public methods                    ////

    /** Add points to the plot.  This is called by the base class
     *  run() method when the plot is live.
     */
    public synchronized void addPoints() {
        // You could plot multiple points at a time here
        // for faster response, but in our case, we really need
        // to slow down the response for visual aesthetics.
     
       try {
            BufferedReader in = new BufferedReader(new FileReader("c:\\plot.txt"));
            line = in.readLine();
            line2 = in.readLine();
            line3 = in.readLine();
            in.close();
        }catch (IOException e) {System.out.println("READ FAILED");}
        
        
        valueY1 = Double.parseDouble(line); 
        valueY2 = Double.parseDouble(line2); 
        valueX1 = 2.0*(Double.parseDouble(line3));
        valueX2 = valueX1+1;
        
        
        if (valueX2 == xupper) {
            //clear the graph
            //valueX = 0;
           // addPoint(0, valueX, valueY, false);
            
            
            xupper+=1;
            xlower+=1;
            
            setXRange(xlower, xupper);
            
            //main("none");
           // clear();
            repaint();
         
        }
        else if ((valueX2 > xupper)&(valueX2 <= (xupper+500))) {
            double temp_A = valueX2-xupper;
            xupper += temp_A;
            xlower += temp_A;
             
        }
        
         if (valueX1 < xupper+500) {
         
        
         if ((valueY1 >= 0.0)&(valueY1 <= 360)&(valueY2 >=0.0)&(valueY2 <= 360)) {
             
            addPoint(0, valueX1, valueY1, true);    
            addPoint(0, valueX2, valueY2, true);
            repaint();
         };
         
         if (valueX1 == 2) {
            clear(0);
            int xupper = 200;
            xlower = -1;
            setXRange(xlower, xupper);
            addPoint(0, valueX1, valueY1, true);    
            addPoint(0, valueX2, valueY2, true);
            repaint();
         }
         
         };
        
        //valueX2 += 1;
        try {
            Thread.sleep(5);
        } catch (InterruptedException e) {}
    }

    /** Run the demo as an application.
     *        This is very useful for debugging.  The command to run would be
     * java -classpath $PTII ptolemy.plot.demo.PlotLiveDemo
     */
    public static void main(String args[]) {
        final PlotLiveDemo plotLiveDemo = new PlotLiveDemo();
        System.runFinalizersOnExit(true);
        JFrame frame = new JFrame("PlotLiveDemo");
        frame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent event) {
                plotLiveDemo.stop();
                System.exit(0);
            }
        });
        frame.getContentPane().add("Center", plotLiveDemo);
        frame.show();
        plotLiveDemo.setButtons(true);
        plotLiveDemo.start();
        frame.pack();
    }



    ///////////////////////////////////////////////////////////////////
    ////                         private variables                 ////

    /** @serial Value being plotted */
    private double _count = 0.0;
}
